SlideShare une entreprise Scribd logo
1  sur  90
Télécharger pour lire hors ligne
Demystifying the SolidWorks API,[object Object],Paul Gimbel, Business Process Sherpa,[object Object],Razorleaf Corporation,[object Object]
What You Will NOT Hear,[object Object],This is an INTRODUCTION to the SolidWorks API,[object Object],Examples – YES,[object Object],Syntax Details – NO,[object Object],Not a lesson on how to use the VBA or VSTA Interface,[object Object],That’s a great idea for another session!,[object Object],Not a programming class,[object Object],Not designed for programmers,[object Object],You won’t hear “Polymorphic Inheritence” used properly in a sentence,[object Object],Slide 2 of 39,430,177,[object Object]
My Main Goal,[object Object],I want you to leave here saying:,[object Object],“I can do that!”,[object Object],“That even looks like fun”,[object Object],“That could save me time”,[object Object],“I could really go for a burrito”,[object Object]
Who Is This Guy and Where Did He Come From?,[object Object],Razorleaf Corporation,[object Object],SolidWorks Service Partner,[object Object],Services ONLY (we’re not trying to sell you anything, we’re neutral),[object Object],Data Management (EPDM, SmarTeam, Aras),[object Object],Design Automation (DriveWorks, Tacton),[object Object],Workflow Automation (Microsoft SharePoint and Tools),[object Object],Paul Gimbel (aka “The Sherpa”),[object Object],10+ years as Demo Jock, Applications Engineer, Trainer, Support Tech,[object Object],5 years as Design Automation Implementer,[object Object],Specializing in SolidWorks, DriveWorks, Tacton, Custom Programming,[object Object],(THERE! Now I can report this trip as reimbursable.),[object Object],The ,[object Object],Sherpa,[object Object]
Where Can I Find Programming?What Languages Can I Use?,[object Object],Macros: Scripts called from inside of SolidWorks to do things automatically,[object Object],Macro Features: Scripts run when at a point in the Feature Manager™,[object Object],Add-Ins: Programs called from inside of SolidWorks through a custom UI,[object Object],Companion Application: Another program’s macros can call SolidWorks,[object Object],Standalone Application: A program that you wrote can call SolidWorks ,[object Object],FREE Visual Studio Express - http://www.microsoft.com/express/product/,[object Object],(Use Coupon Code “RAZORLEAF”),[object Object]
Why VB.NET?,[object Object],This presentation uses VB.NET (VSTA) Macros,[object Object],Macro Recorder (2010) supports VBA, VB.NET, C#.NET,[object Object],All built into SolidWorks ,[object Object],VBA and VSTA (Visual Studio Tools for Applications) development environments are included with SolidWorks,[object Object],VB.NET is the current version of VB,[object Object],VBA is based on VB6 (1998 technology, Support ended 2008),[object Object],NOBODY uses VBA anymore…well, except Microsoft Office,[object Object],Even AutoDesk dropped VBA out of AutoCAD products in January 2010,[object Object],Tons of examples are out there in VB, more than any other language,[object Object],Most SolidWorks examples are in VBA (since they’re old),[object Object],Not too difficult to convert from VBA to VB.NET,[object Object]
Macro Myths,[object Object],Macros are in VBA,[object Object],No Forms/Dialogs,[object Object],Cannot be automated,[object Object],Require you to preselect,[object Object],Cannot handle advanced functionality (like classes),[object Object]
The Ultimate Process For Non-Programmers,[object Object],Determine what you want your program/code snippet to do,[object Object],Think of some “keywords” to describe it (if you know the functions you need to use, you’re ahead of the game),[object Object],http://www.google.com (add “VB” or “Visual Basic”),[object Object],Ctrl-C,[object Object],Ctrl-V,[object Object],Tweak,[object Object],Test,[object Object],Tweak,[object Object],Test,[object Object],Repeat steps 6-10 ad nauseum,[object Object],Also check out,[object Object],www.krugle.org  and,[object Object],www.sourceforge.net,[object Object],Also look to VBA/VSTA and SW API Help files. ,[object Object],They’re actually somewhat helpful with good examples. ,[object Object],I know! I was shocked, too.,[object Object]
Object-Oriented Programming**,[object Object],“Everything you need to do in the SolidWorks API has to be done by or to an object.”,[object Object],Class – A definition (blueprint) of something (think: blank spec for a washer or bolt),[object Object],Interface – A more generic definition incorporating multiple classes (ex. Hardware),[object Object],Object – A specific instance of a class (completed spec - ex. 1/4-20 x 3 SHCS),[object Object],Property – A parameter value that an object has (ex. Diameter),[object Object],Method – Something (sub or function) that an object can do (ex. Install),[object Object],Accessor – A method used to get an object (ex. GetFeature, GetChildren),[object Object],Dot(.) –Separates an object from its property or method or “child” objects,[object Object],Ex. Bolt.Length or Bolt.Thread.item(“Lead”).Pitch,[object Object],Instantiate – To make a real thing as defined by a class,[object Object],Ex. Upper Flange Bolt #3 or Rear Axle Nut,[object Object],Those are then called “instances” and “objects”,[object Object],**To appease any true code junkies out there. VBA doesn’t REALLY support full OOP with inheritance and polymorphism, but this is a DEMYSTIFYING session. I don’t want to MYSTIFY this stuff any more than it is.,[object Object]
SolidWorks Objects,[object Object],“Everything you need to do in the SolidWorks API has to be done by or to an object.”,[object Object],Everything in SolidWorks (even SolidWorks itself) has an object,[object Object],The SolidWorks Object Model is a hierarchy of objects/classes/interfaces,[object Object],You use an object higher in the tree to fetch an object “beneath” it (accessors),[object Object],Be prepared to go several steps down (objects beget objects beget objects…),[object Object],Be VERY SPECIFIC as to what type of objects you have (fully qualified),[object Object],Easier to read,[object Object],Easier to write (Microsoft will help you),[object Object],Learn your way around the HELP file to figure out the object path you need,[object Object],Throwing darts is most effective in many cases,[object Object]
The SolidWorks API Object Example (VBA),[object Object],Early Bound Object Declarations aka “Fully Qualified” (+5 Style Points),[object Object],Object assignment (instantiation) requires the keyword Set in VBA only,[object Object],HoleDepth and HoleDiameter are Properties,[object Object],of the WizardHoleFeatureData2 object,[object Object],Example: Creating a Hole Wizard Hole,[object Object],Dim swApp As SldWorks.SldWorks,[object Object],Dim swModel As SldWorks.ModelDoc2,[object Object],Dim swFeatMgr As SldWorks.FeatureManager,[object Object],Dim swFeat As SldWorks.Feature,[object Object],Dim swWzdHole As WizardHoleFeatureData2,[object Object],Set swApp = Application.SldWorks,[object Object],Set swModel = swApp.ActiveDoc,[object Object],Set swFeatMgr = swModel.FeatureManager,[object Object],…more code here…,[object Object],Set swWzdHole = swFeatMgr.CreateDefinition(swFmHoleWzd),[object Object],swWzdHole.HoleDepth = 0.15,[object Object],swWzdHole.HoleDiameter = 0.0555,[object Object],…,[object Object],Set swFeat = swFeatMgr.CreateFeature(swWzdHole),[object Object],…more code here…,[object Object],CreateDefinition and CreateFeature are Methods (functions),[object Object]
Seek Professional HelpAn Interface Definition in the API Help,[object Object]
Seek Professional HelpAn Interface Definition in the API Help,[object Object], Members = Properties and Methods,[object Object]
Seek Professional HelpAn Interface Definition in the API Help,[object Object],Properties have Get and/or Set,[object Object],               x = object.property (Get),[object Object],object.property = x (Set),[object Object],Methods are actions an object performs,[object Object]
Seek Professional HelpAn Interface Definition in the API Help,[object Object],This has Get only. It’s an accessor.,[object Object]
Seek Professional HelpAn Interface Definition in the API Help,[object Object],This is no longer a property. It now uses methods to get and set it.,[object Object],(And forget it),[object Object]
Seek Professional HelpAn Interface Definition in the API Help,[object Object],Old functions never die…,[object Object]
The SolidWorks API Development Process,[object Object]
API Sample #1,[object Object],Cycle Through All Configurations of a Part,[object Object]
What The Macro Does,[object Object],Grabs the current open part document (Works only for parts),[object Object],Grabs a list of all of the configuration names,[object Object],Loops through the configurations one at a time,[object Object],Changes the Material of the configuration,[object Object],Saves a PDF of the configuration,[object Object],Sets a configuration-specific custom property value,[object Object]
Important Concepts – Example 1,[object Object],Programmatic Framework,[object Object],Accessing Objects,[object Object],ModelDoc/PartDoc Objects,[object Object],Accessing / Looping Through Configurations,[object Object],Editing Material Properties,[object Object],SaveAs – Exporting File Formats,[object Object],Adding Custom Properties,[object Object]
The SolidWorks API Development Process,[object Object]
Macro Record (VB.NET) – 1 of 2,[object Object],Legend,[object Object],Imports SolidWorks.Interop.sldworks,[object Object],Imports SolidWorks.Interop.swconst,[object Object],Imports System,[object Object],Partial Class SolidWorksMacro,[object Object],     Public Sub main(),[object Object],            Dim swDoc As ModelDoc2 = Nothing,[object Object],            Dim swPart As PartDoc = Nothing,[object Object],            Dim swDrawing As DrawingDoc = Nothing,[object Object],            Dim swAssembly As AssemblyDoc = Nothing,[object Object],            Dim boolstatus As Boolean = false,[object Object],            Dim longstatus As Integer = 0,[object Object],            Dim longwarnings As Integer = 0,[object Object],swDoc = CType(swApp.ActiveDoc,ModelDoc2),[object Object],boolstatus = swDoc.Extension.SelectByID2("Unknown", "BROWSERITEM", 0, 0, 0, false, 0, Nothing, 0),[object Object],            swDoc.ClearSelection2(true),[object Object],swPart = CType(swDoc,PartDoc),[object Object],            swPart.SetMaterialPropertyName2("Copper", "C:/Program Files/SW/lang/english/sldmaterials/SolidWorks "& _ ,[object Object],                    "Materials.sldmat", "Copper"),[object Object],useless Content,[object Object]
Macro Record (VB.NET) – 2 of 2,[object Object],	        swDoc.ClearSelection2(true),[object Object],boolstatus = swDoc.Extension.SelectByID2("Brass", "CONFIGURATIONS", 0, 0, 0, false, 0, Nothing, 0),[object Object],boolstatus = swDoc.Extension.SelectByID2("Brass", "CONFIGURATIONS", 0, 0, 0, false, 0, Nothing, 0),[object Object],boolstatus = swDoc.Extension.SelectByID2("Brass", "CONFIGURATIONS", 0, 0, 0, false, 0, Nothing, 0),[object Object],boolstatus = swDoc.Extension.SelectByID2("Brass", "CONFIGURATIONS", 0, 0, 0, false, 0, Nothing, 0),[object Object],boolstatus = swDoc.ShowConfiguration2("Brass"),[object Object],boolstatus = swDoc.Extension.SelectByID2("Unknown", "BROWSERITEM", 0, 0, 0, false, 0, Nothing, 0),[object Object],            swDoc.ClearSelection2(true),[object Object],End Sub,[object Object], ,[object Object],''' <summary>,[object Object],    ''' The SldWorksswApp variable is pre-assigned for you.,[object Object],    ''' </summary>,[object Object],Public swApp As SldWorks,[object Object], ,[object Object],End Class,[object Object],The Summary explains what the macro does and how it works (that’s why it’s shoved at the end like an afterthought),[object Object],This is SUCH an important variable that SolidWorks makes it PUBLIC (then stuffs it at the end where nobody sees it),[object Object]
Basic Framework (VB.NET),[object Object],(Final code does NOT have these),[object Object],Imports SolidWorks.Interop.sldworks,[object Object],Imports SolidWorks.Interop.swconst,[object Object],Partial Class SolidWorksMacro,[object Object], ,[object Object],''' <summary>,[object Object], 	 ''' Put a description, tracking and revision information here,[object Object],    ''' </summary>,[object Object],Public swApp As SldWorks,[object Object],	Public Sub main(),[object Object],Your code goes here ,[object Object],End Sub ‘main,[object Object],End Class ‘SolidWorksMacro,[object Object],Shortcut,[object Object],Shortcut,[object Object],!!!ALWAYS Use ,[object Object],macro record ,[object Object],or ,[object Object],Tools>Macro>New!!!,[object Object]
Basic Framework (VB.NET),[object Object],Imports SolidWorks.Interop.sldworks,[object Object],Imports SolidWorks.Interop.swconst,[object Object],Partial Class SolidWorksMacro,[object Object], ,[object Object],''' <summary>,[object Object], 	 ''' Put a description, tracking and revision information here,[object Object],    ''' </summary>,[object Object],Public swApp As SldWorks,[object Object],	Public Sub main(),[object Object],Your code goes here ,[object Object],End Sub ‘main,[object Object],End Class ‘SolidWorksMacro,[object Object],DO NOT RENAME HERE,[object Object],PARTIAL means there’s other stuff you don’t see…LOTS of it.,[object Object]
Renaming Classes,[object Object],If you feel that you MUST rename things,[object Object],Rename from the Project Explorer,[object Object],It will make the update where it needs to,[object Object],Don’t believe me there’s lots you can’t see? Just click on SHOW ALL.,[object Object]
Basic Framework (VB.NET),[object Object],Imports SolidWorks.Interop.sldworks,[object Object],Imports SolidWorks.Interop.swconst,[object Object],Partial Class SolidWorksMacro,[object Object], ,[object Object],''' <summary>,[object Object], 	 ''' Put a description, tracking and revision information here,[object Object],  ''' </summary>,[object Object],Public swApp As SldWorks,[object Object],	Public Sub main(),[object Object],Your code goes here ,[object Object],End Sub ‘main,[object Object],End Class ‘SolidWorksMacro,[object Object],Move these up from the bottom of the class,[object Object]
The SolidWorks API Development Process,[object Object]
Do Your Research: HELP>API HELP,[object Object]
Keep Following The Trail,[object Object]
We’ve Got a Lead!,[object Object],Variants have (rightly) been BANNED from .NET,[object Object]
OK, Now To Find The Method,[object Object]
OK, Now To Find The Method,[object Object],!!,[object Object],!!,[object Object],!!,[object Object],!!,[object Object]
Performance Characteristics of Key Muppets on Syndicated Educational Television Programs,[object Object],Mandatory Charts (Gratuitous Chart of Fictitious Data)(per Microsoft PowerPoint code 2009 Section XXIV Subsection 441.K.9.ii.v),[object Object]
The SolidWorks API Development Process,[object Object]
Instantiating an Object Class,[object Object],Visual Basic.NET requires you to declare your variables,[object Object],Declare…,[object Object],PUBLICvariablenameASclassname,[object Object],DIMvariablenameASclassname,[object Object],Assign…,[object Object],variablename = otherVariable.accessor(),[object Object],Sometimes you need to guarantee the class,[object Object],variablename = Ctype(oVar.accessor, Class),[object Object],variablename = DirectCast(oVar, Class),[object Object]
Variables! Get Yer Variables Right Here!,[object Object],PUBLIC declare variables that can be used outside of the module,[object Object],Useful for your SldWorks.SldWorks and ModelDoc objects,[object Object],Macro Recorder puts these at the bottom, we recommend the top,[object Object],DIM or PRIVATE declares a variable for use within a function or sub,[object Object],Imports SolidWorks.Interop.Sldworks,[object Object],Partial Class SolidWorksMacro,[object Object],'''<Summary>    ,[object Object],	  '''Fill this in at some point,[object Object],    '''</Summary>,[object Object],    'Declare the SolidWorks application as global so it can be used throughout the class,[object Object],PublicswApp As SldWorks'SW Application Object,[object Object],PublicSub main(),[object Object],DimbStatusAs Boolean = False   ‘Used as SolidWorks return for most functions,[object Object],DimiErrorsAs Integer = 0,[object Object],DimiWarningsAs Integer = 0,[object Object],DimConfigNames() AsString‘The list of names that we’re going to get back,[object Object],Declare and define in one step,[object Object],You can define as you go,[object Object]
You’ve Declared, Now Define,[object Object],SET Keyword is not required for VB.NET or C#.NET (a must in VBA),[object Object],Macro Record or Tools>Macro>New will get your SolidWorks object for you,[object Object],3 Methods of instantiating your SldWorks.SldWorks Object (VBA),[object Object],swApp = Application.SldWorks,[object Object],Grabs existing application (open session REQUIRED),[object Object],OK to use in macros,[object Object],swApp = GetObject( , “SldWorks.Application”),[object Object],First parameter is a pathname of file to open,[object Object],Second parameter is object class,[object Object],Must have one or the other,[object Object],If no pathname is specified and SolidWorks is not open, error will occur,[object Object],swApp = CreateObject(“SldWorks.Application”),[object Object],Grabs open SolidWorks application,[object Object],If no SolidWorks application is open, starts a SolidWorks instance,[object Object]
Use swApp.ActiveDoc to grab currently open document,[object Object],or ActivateDoc or OpenDoc7 or LoadFile4 or…,[object Object],Ctype guarantees that we’re getting a ModelDoc2 object,[object Object],Check API for return, some return “object”,[object Object],ALWAYS TEST FOR PRESENCE OF AN OBJECT,[object Object],'Grab the object for the Active SolidWorks Model,[object Object],DimswDocAs ModelDoc2 ,[object Object],swDoc = CType(swApp.ActiveDoc, ModelDoc2),[object Object],  'Make sure that we have a document object,[object Object],	'If we have no model document object to work with, we cannot go on,[object Object],IfswDocIs Nothing Then Exit Sub,[object Object],Got ModelDoc2?,[object Object],got 3D?,[object Object],Test Early, Test Often,[object Object]
What is ModelDoc2?...Part? Assembly? Drawing? Yup.,[object Object],PartDoc Object,[object Object],MirrorPart,[object Object],SetMaterialPropertyName2,[object Object],AssemblyDoc Object,[object Object],AddComponent,[object Object],EditMate,[object Object],DrawingDoc Object,[object Object],ActivateView,[object Object],InsertWeldSymbol,[object Object],ModelDoc2 Object,[object Object],[object Object]
CreateLine
EditConfiguration
FeatureCut
FirstFeature
ForceRebuild
InsertNote
Parameter
SaveAs
SetUnits
SketchFillet
…everything else usefulModelDoc2.Extension,[object Object],[object Object]
GetAnnotations
InsertBomTable
SaveAs
SetUserPreferencex
…and lots more,[object Object]
The SolidWorks API Development Process,[object Object]
Get PartDoc and Change Materials,[object Object],[object Object]
PartDoc comes directly from ModelDoc2 (DirectCast)
So do AssemblyDoc and DrawingDoc
If there’s a doubt, use Ctype (IF typeofswPart IS PartDoc…)
WARNING!! You may suffer SEVERAL MILLISECONDS performance degradation!!'Setting the Material is a method of the PartDoc object. We get that object by recasting the ModelDoc2 object.,[object Object],'WE ONLY USE DIRECTCAST BECAUSE WE’VE TESTED swDoc.GetType. WE ARE CERTAIN IT IS A PART!!!,[object Object],DimswPartAsPartDoc = DirectCast(swDoc, PartDoc),[object Object],…Back in the loop…,[object Object],'Set the material property for this configuration. This assumes that the configuration name matches an existing material.,[object Object],swPart.SetMaterialPropertyName2(ConfigName, “M:/RazorleafMatlLib/Materials.sldmat", ConfigName),[object Object],We want to do this outside the loop so we only do it once,[object Object]
Save the Model Out As a PDF,[object Object],'Do a zoom to fit,[object Object],swDoc.ViewZoomtofit2(),[object Object],'Retrieve the full pathname including the file name,[object Object],DimsFileNameAsString = swDoc.GetPathName,[object Object],'Remove the extension,[object Object],sFileName = sFileName.Remove(sFileName.LastIndexOf(".")) 'remove all text after the last dot,[object Object],bStatus = swDoc.Extension.SaveAs(sFileName & "_" & ConfigNames(index) & ".pdf", _,[object Object],swSaveAsVersion_e.swSaveAsCurrentVersion, _,[object Object],swSaveAsOptions_e.swSaveAsOptions_Silent, _,[object Object],    Nothing, iErrors, iWarnings),[object Object],.NET string members, check ‘em out!,[object Object],_ means “Continued on next line”,[object Object],    Must have a space before it,[object Object],enumerations,[object Object],More return values, listed as ByRef in the Class Definition,[object Object]
Enumerations,[object Object],Parameter values can be integer or long in many cases,[object Object],What is the integer for SolidWorks 2009?,[object Object],Enumerations replace numbers,[object Object],IMPORTS SolidWorks.Interop.swconst,[object Object],That’s the Type Constant Library,[object Object],My code fully qualifies,[object Object],Intellisense will help you if you fully qualify,[object Object],Enumerations are more readable  ,[object Object],ByVal means input,[object Object],ByRef means output,[object Object]
Set Configuration-Specific Custom Property,[object Object],[object Object]
Be sure to comment your loop and IF closers                  swDoc.AddCustomInfo3(ConfigName, "Material Code", _,[object Object],swCustomInfoType_e.swCustomInfoText, ConfigName.Remove(4)),[object Object],NextConfigName'move to the next configuration,[object Object],End If 'there are one or more configurations in the document,[object Object],End Sub ‘main,[object Object],End Class ‘SolidWorksMacro,[object Object],Another kewl .NET string function,[object Object],Documenting here makes blocks easier to follow and troubleshoot,[object Object]
Configuration Master 5000 ,[object Object],Complete Code,[object Object]
Final Code: Configuration Master 5000 (Part 1 of 5),[object Object],Partial Class SolidWorksMacro,[object Object],'''<Summary>,[object Object],    '''Sample Code for SolidWorks World 2010: Demystifying the SolidWorks API,[object Object],    '''Razorleaf Corporation -- Paul Gimbel -- January 20, 2010,[object Object],    '''This macro loops through all of the configurations of a part,[object Object],    '''For each configuration, it saves a PDF, changes the material of the configuration and adds a configuration-specific custom property,[object Object],    '''See the Powerpoint Presentation (available from www.razorleaf.com) for complete documentation of the code,[object Object],    '''</Summary>,[object Object],    'Declare the SolidWorks application as a global variable so it can be used throughout the class,[object Object],PublicswApp As SolidWorks.Interop.sldworks.SldWorks    'SolidWorks Application Object,[object Object],PublicSub main(),[object Object],DimbStatusAs Boolean = False,[object Object],DimiErrorsAs Integer = 0,[object Object],DimiWarningsAs Integer = 0,[object Object],DimConfigNames() AsString,[object Object]
Final Code: Configuration Master 5000 (Part 2 of 5),[object Object],        'Grab the object for the Active SolidWorks Model,[object Object],DimswDocAs SolidWorks.Interop.sldworks.ModelDoc2 = CType(swApp.ActiveDoc, SolidWorks.Interop.sldworks.ModelDoc2),[object Object],        'Make sure that we got a document object,[object Object],IfswDocIs Nothing Then Exit Sub 'We have no model document to work with, we cannot go on,[object Object],        'This macro is only for part models. Check what type of document we have.,[object Object],IfswDoc.GetType <> SolidWorks.Interop.swconst.swDocumentTypes_e.swDocPARTThen Exit Sub,[object Object],        'Get the list of configuration names. This will be blank where it's not appropriate.,[object Object],ConfigNames = swDoc.GetConfigurationNames,[object Object],         'Setting the Material is a method of the PartDoc object. We get that object by recasting the ModelDoc2 object.,[object Object],          'WE ONLY USE DIRECTCAST BECAUSE WE HAVE ALREADY TESTED swDoc.GetType. WE ARE CERTAIN IT IS A PART!!!,[object Object],DimswPartAsSolidWorks.Interop.sldworks.PartDoc = DirectCast(swDoc, SolidWorks.Interop.sldworks.PartDoc),[object Object],          If ConfigNames.Length >= 1 Then,[object Object],For Each ConfigNameAs String In ConfigNames,[object Object],                'Switch to the current configuration,[object Object],bStatus = swDoc.ShowConfiguration2(ConfigNames(index)),[object Object]
Final Code: Configuration Master 5000 (Part 3 of 5),[object Object],                ''<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,[object Object],                ''Drive the material to be equal to the configuration name,[object Object],                ''<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,[object Object],                'Set the material property for this configuration. This assumes that the configuration name matches an existing material.,[object Object],                swPart.SetMaterialPropertyName2(ConfigNames(index), _,[object Object],                    "C:/Program Files/SolidWorks Corp/SolidWorks/lang/english/sldmaterials/SolidWorks " & "Materials.sldmat", _,[object Object],ConfigNames(index)),[object Object]
Final Code: Configuration Master 5000 (Part 4 of 5),[object Object],                ''<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,[object Object],                ''Save this configuration out as a PDF,[object Object],                ''<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,[object Object],                'Do a zoom to fit,[object Object],                swDoc.ViewZoomtofit2(),[object Object],                'Retrieve the full pathname including the file name,[object Object],DimsFileNameAsString = swDoc.GetPathName,[object Object],'Remove the extension,[object Object],sFileName = sFileName.Remove(sFileName.LastIndexOf(".")) 'remove from the location of the last dot on to the end,[object Object],bStatus = swDoc.Extension.SaveAs(sFileName & "_" & ConfigNames(index) & ".pdf", _,[object Object],                        SolidWorks.Interop.swconst.swSaveAsVersion_e.swSaveAsCurrentVersion, _,[object Object],                        SolidWorks.Interop.swconst.swSaveAsOptions_e.swSaveAsOptions_Silent, _,[object Object],Nothing, iErrors, iWarnings),[object Object]
Final Code: Configuration Master 5000 (Part 5 of 5),[object Object],                ''<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,[object Object],                ''Create a configuration specific custom property - ,[object Object],                ''     Material Code = 1st 4 letters of the material,[object Object],                ''<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,[object Object],                'Setting the Material is a method of the PartDoc object. We get that object by recasting the ModelDoc2 object.,[object Object],                swDoc.AddCustomInfo3(ConfigNames(index), "Material Code", _,[object Object],SolidWorks.Interop.swconst.swCustomInfoType_e.swCustomInfoText, _,[object Object],ConfigNames(index).Remove(4)),[object Object],NextConfigName'move to the next configuration,[object Object],End If 'there are one or more configurations in the document,[object Object],End Sub ‘main,[object Object],End Class ‘SolidWorksMacro,[object Object]
The SolidWorks API Development Process,[object Object]
API Example #2,[object Object],Suppressing Pattern Instances,[object Object]
Delete Pattern Instances,[object Object],Part has one or more linear patterns,[object Object],Custom property stores a text string of Xs and Os,[object Object],X means there will be an instance here,[object Object],O means that instance will be removed,[object Object],Main Errors to check for:,[object Object],No pattern features,[object Object],No instance to suppress,[object Object],Text string length ≠ Number of pattern instances,[object Object],XOOXXOXOOXOXOOXOXOOXOXOO,[object Object]
Important Concepts – Example 2,[object Object],Accessing Feature objects,[object Object],Looping through all features in a part,[object Object],Handling FeatureData objects,[object Object],Reading custom properties,[object Object]
The SolidWorks API Development Process,[object Object]
Recorded Macro: Remove Pattern Instances,[object Object],Legend,[object Object],   Public Sub main(),[object Object],            Dim swDoc As ModelDoc2 = Nothing,[object Object],            Dim swPart As PartDoc = Nothing,[object Object],            Dim swDrawing As DrawingDoc = Nothing,[object Object],            Dim swAssembly As AssemblyDoc = Nothing,[object Object],            Dim boolstatus As Boolean = false,[object Object],            Dim longstatus As Integer = 0,[object Object],            Dim longwarnings As Integer = 0,[object Object],swDoc = CType(swApp.ActiveDoc,ModelDoc2),[object Object],            Dim myModelView As ModelView = Nothing,[object Object],myModelView = CType(swDoc.ActiveView,ModelView),[object Object],myModelView.FrameState = CType(swWindowState_e.swWindowMaximized,Integer),[object Object],boolstatus = swDoc.Extension.SelectByID2("HolePattern", "BODYFEATURE", …),[object Object],            swDoc.ClearSelection2(true),[object Object],boolstatus = swDoc.Extension.SelectByID2("", "EDGE", -0.04, 0.0127,…),[object Object],boolstatus = swDoc.Extension.SelectByID2("", "EDGE", -0.1016, …),[object Object],swDoc.ActivateSelectedFeature(),[object Object],    End Sub,[object Object],Helpful Content,[object Object]
The SolidWorks API Development Process,[object Object]
Seek the Path of Enlightenment,[object Object],How do we get the info we need out of the object?,[object Object],How do we get the object?,[object Object]
Find The Right Property or Method,[object Object]
OK, So How Do We Get The Object, Then?,[object Object],Accessors List,[object Object]
IFeature.ILinearPatternFeatureData.SkippedItemArray,[object Object],Let’s limit it to just ModelDoc2 and PartDoc,[object Object],Once you have a feature, you can use it to get the next one,[object Object]
The Full Object Path,[object Object],ModelDoc2,[object Object],Feature,[object Object],Feature IS Linear Pattern,[object Object],Feature IS NOT Linear Pattern,[object Object],LinearPattern,[object Object],FeatureData,[object Object]
The SolidWorks API Development Process,[object Object]
Set up the Framework and Grab the ModelDoc2,[object Object],IMPORTS SolidWorks.Interop.sldworks,[object Object],IMPORTS SolidWorks.Interop.swconst,[object Object],Partial Class SolidWorksMacro,[object Object],''' <summary>,[object Object],    ''' Don’t forget to put this in at some point!!,[object Object],    ''' </summary>,[object Object],PublicswAppAsSldWorks,[object Object],Public Sub main(),[object Object],‘A nice description here goes a long way!,[object Object],'Get currently open document,[object Object],DimswPartAs ModelDoc2 = CType(swApp.ActiveDoc, ModelDoc2),[object Object],'Make sure that we have an object,[object Object],IfswDocIs Nothing Then Exit Sub,[object Object],    'This macro is only for part models. Check our document type.,[object Object],IfswDoc.GetType <> swDocumentTypes_e.swDocPARTThen Exit Sub,[object Object]
The SolidWorks API Development Process,[object Object]
Test for Proper Conditions and Get Feature Object,[object Object],'Fetch the custom property list,[object Object],DimsInputListAs String = swDoc.GetCustomInfoValue("", "SkipList"),[object Object],'If the list does not exist, exit out of the function. We do not need to run the macro.,[object Object],        If sInputList.Length < 1 Then Exit Sub,[object Object],        'Get the first feature in the part. ,[object Object],		'NOTE!! THIS DOES NOT MEAN THE BASE EXTRUSION. ,[object Object],		'There are reference features.,[object Object],DimswFeatureAs Feature ,[object Object],swFeature = swDoc.FirstFeature(),[object Object],Declare as you define,[object Object],Always put your tests up front - Try to run as little code as possible,[object Object],Look how far down the tree the base extrusion is!,[object Object]
Loop the Loop,[object Object],'We know from our research that we'll need the LinearPatternFeatureData,[object Object],	       ' object, the feature type, and some indices. ,[object Object],        'We'll declare them outside of the loop so they only get declared once.,[object Object],DimswFeatureDataAsLinearPatternFeatureData,[object Object],DimsFeatureTypeAs String      'Type of feature,[object Object],DimiRowsAs Integer            'Number of rows in the pattern,[object Object],DimiColsAs Integer            'Number of columns in the pattern,[object Object],DimTempStringAs String = "",[object Object],		Do While swFeatureIsNotNothing'loop through the features,[object Object],          …OUR CODE GOES HERE…,[object Object],Loop,[object Object],DO WHILE tests BEFORE running any code,[object Object],(Do … Loop Until tests after),[object Object],Got an object? ,[object Object],IsNot Nothing will tell you,[object Object]

Contenu connexe

Tendances

ETAP - Introduccion al etap etap 12
ETAP - Introduccion al etap etap 12ETAP - Introduccion al etap etap 12
ETAP - Introduccion al etap etap 12Himmelstern
 
Introducing Application Context - from the PL/SQL Potpourri
Introducing Application Context - from the PL/SQL PotpourriIntroducing Application Context - from the PL/SQL Potpourri
Introducing Application Context - from the PL/SQL PotpourriLucas Jellema
 
ppt on summer training on solidworks
ppt on summer training on solidworksppt on summer training on solidworks
ppt on summer training on solidworksShubham Agarwal
 
3rd Year Formula Student Frame Project Report
3rd Year Formula Student Frame Project Report3rd Year Formula Student Frame Project Report
3rd Year Formula Student Frame Project ReportJessica Byrne
 
Creo parametric tips and tricks
Creo parametric tips and tricksCreo parametric tips and tricks
Creo parametric tips and tricksEvan Winter
 
Solidworks training report
Solidworks training reportSolidworks training report
Solidworks training reportPawan Kumar
 
Tài liệu tự học Auto lisp
Tài liệu tự học Auto lispTài liệu tự học Auto lisp
Tài liệu tự học Auto lispTrung Thanh Nguyen
 
Hướng dẫn gia công trên Creo
Hướng dẫn gia công trên CreoHướng dẫn gia công trên Creo
Hướng dẫn gia công trên CreoCadcamcnc Học
 
Giáo trình Powermill 2018 cho người mới học
Giáo trình Powermill 2018 cho người mới họcGiáo trình Powermill 2018 cho người mới học
Giáo trình Powermill 2018 cho người mới họcỨng Dụng Máy Tính
 
Solidworks ppt 2015
Solidworks ppt 2015Solidworks ppt 2015
Solidworks ppt 2015lalit yadav
 
Hướng dẫn lập trình cơ bản Powermill 2015
Hướng dẫn lập trình cơ bản Powermill 2015Hướng dẫn lập trình cơ bản Powermill 2015
Hướng dẫn lập trình cơ bản Powermill 2015Cadcamcnc Học
 
bộ truyền xích.pdf
bộ truyền xích.pdfbộ truyền xích.pdf
bộ truyền xích.pdfssuser8f1f77
 
Hướng dẫn phân tích mô phỏng solidworks (demo)
Hướng dẫn phân tích mô phỏng solidworks (demo)Hướng dẫn phân tích mô phỏng solidworks (demo)
Hướng dẫn phân tích mô phỏng solidworks (demo)Trung tâm Advance Cad
 
Robust Shape and Topology Optimization - Northwestern
Robust Shape and Topology Optimization - Northwestern Robust Shape and Topology Optimization - Northwestern
Robust Shape and Topology Optimization - Northwestern Altair
 
Libro básico de arduino electrónica y programación varios autores
Libro básico de arduino  electrónica y programación   varios autoresLibro básico de arduino  electrónica y programación   varios autores
Libro básico de arduino electrónica y programación varios autoresComyc Cafetería
 
Lập trình gia công cơ bản Powermill (demo)
Lập trình gia công cơ bản Powermill (demo)Lập trình gia công cơ bản Powermill (demo)
Lập trình gia công cơ bản Powermill (demo)Trung tâm Advance Cad
 

Tendances (20)

Solid works ppt
Solid works pptSolid works ppt
Solid works ppt
 
ETAP - Introduccion al etap etap 12
ETAP - Introduccion al etap etap 12ETAP - Introduccion al etap etap 12
ETAP - Introduccion al etap etap 12
 
Introducing Application Context - from the PL/SQL Potpourri
Introducing Application Context - from the PL/SQL PotpourriIntroducing Application Context - from the PL/SQL Potpourri
Introducing Application Context - from the PL/SQL Potpourri
 
ppt on summer training on solidworks
ppt on summer training on solidworksppt on summer training on solidworks
ppt on summer training on solidworks
 
3rd Year Formula Student Frame Project Report
3rd Year Formula Student Frame Project Report3rd Year Formula Student Frame Project Report
3rd Year Formula Student Frame Project Report
 
100 CAD exercises
100 CAD exercises100 CAD exercises
100 CAD exercises
 
Creo parametric tips and tricks
Creo parametric tips and tricksCreo parametric tips and tricks
Creo parametric tips and tricks
 
MCCB Easy Pact ECLB
MCCB Easy Pact ECLBMCCB Easy Pact ECLB
MCCB Easy Pact ECLB
 
Solidworks training report
Solidworks training reportSolidworks training report
Solidworks training report
 
Tài liệu tự học Auto lisp
Tài liệu tự học Auto lispTài liệu tự học Auto lisp
Tài liệu tự học Auto lisp
 
Hướng dẫn gia công trên Creo
Hướng dẫn gia công trên CreoHướng dẫn gia công trên Creo
Hướng dẫn gia công trên Creo
 
Giáo trình Powermill 2018 cho người mới học
Giáo trình Powermill 2018 cho người mới họcGiáo trình Powermill 2018 cho người mới học
Giáo trình Powermill 2018 cho người mới học
 
Solidworks ppt 2015
Solidworks ppt 2015Solidworks ppt 2015
Solidworks ppt 2015
 
Creo Demo
Creo DemoCreo Demo
Creo Demo
 
Hướng dẫn lập trình cơ bản Powermill 2015
Hướng dẫn lập trình cơ bản Powermill 2015Hướng dẫn lập trình cơ bản Powermill 2015
Hướng dẫn lập trình cơ bản Powermill 2015
 
bộ truyền xích.pdf
bộ truyền xích.pdfbộ truyền xích.pdf
bộ truyền xích.pdf
 
Hướng dẫn phân tích mô phỏng solidworks (demo)
Hướng dẫn phân tích mô phỏng solidworks (demo)Hướng dẫn phân tích mô phỏng solidworks (demo)
Hướng dẫn phân tích mô phỏng solidworks (demo)
 
Robust Shape and Topology Optimization - Northwestern
Robust Shape and Topology Optimization - Northwestern Robust Shape and Topology Optimization - Northwestern
Robust Shape and Topology Optimization - Northwestern
 
Libro básico de arduino electrónica y programación varios autores
Libro básico de arduino  electrónica y programación   varios autoresLibro básico de arduino  electrónica y programación   varios autores
Libro básico de arduino electrónica y programación varios autores
 
Lập trình gia công cơ bản Powermill (demo)
Lập trình gia công cơ bản Powermill (demo)Lập trình gia công cơ bản Powermill (demo)
Lập trình gia công cơ bản Powermill (demo)
 

Similaire à Demystifying The Solid Works Api

Robotlegs on Top of Gaia
Robotlegs on Top of GaiaRobotlegs on Top of Gaia
Robotlegs on Top of GaiaJesse Warden
 
JavaOne TS-5098 Groovy SwingBuilder
JavaOne TS-5098 Groovy SwingBuilderJavaOne TS-5098 Groovy SwingBuilder
JavaOne TS-5098 Groovy SwingBuilderAndres Almiray
 
From Legacy to Hexagonal (An Unexpected Android Journey)
From Legacy to Hexagonal (An Unexpected Android Journey)From Legacy to Hexagonal (An Unexpected Android Journey)
From Legacy to Hexagonal (An Unexpected Android Journey)Jose Manuel Pereira Garcia
 
Javascript unit testing, yes we can e big
Javascript unit testing, yes we can   e bigJavascript unit testing, yes we can   e big
Javascript unit testing, yes we can e bigAndy Peterson
 
닷넷 개발자를 위한 패턴이야기
닷넷 개발자를 위한 패턴이야기닷넷 개발자를 위한 패턴이야기
닷넷 개발자를 위한 패턴이야기YoungSu Son
 
#SPSEMEA SharePoint & jQuery - What I wish I would have known a year ago..
#SPSEMEA SharePoint & jQuery - What I wish I would have known a year ago..#SPSEMEA SharePoint & jQuery - What I wish I would have known a year ago..
#SPSEMEA SharePoint & jQuery - What I wish I would have known a year ago..Mark Rackley
 
CodeMash - Building Rich Apps with Groovy SwingBuilder
CodeMash - Building Rich Apps with Groovy SwingBuilderCodeMash - Building Rich Apps with Groovy SwingBuilder
CodeMash - Building Rich Apps with Groovy SwingBuilderAndres Almiray
 
HTML5 for the Silverlight Guy
HTML5 for the Silverlight GuyHTML5 for the Silverlight Guy
HTML5 for the Silverlight GuyDavid Padbury
 
SharePoint Cincy 2012 - jQuery essentials
SharePoint Cincy 2012 - jQuery essentialsSharePoint Cincy 2012 - jQuery essentials
SharePoint Cincy 2012 - jQuery essentialsMark Rackley
 
Smoothing Your Java with DSLs
Smoothing Your Java with DSLsSmoothing Your Java with DSLs
Smoothing Your Java with DSLsintelliyole
 
MobiConf 2018 | Room: an SQLite object mapping library
MobiConf 2018 | Room: an SQLite object mapping library MobiConf 2018 | Room: an SQLite object mapping library
MobiConf 2018 | Room: an SQLite object mapping library Magda Miu
 
Advisor Jumpstart: JavaScript
Advisor Jumpstart: JavaScriptAdvisor Jumpstart: JavaScript
Advisor Jumpstart: JavaScriptdominion
 
SharePoint Saturday St. Louis - SharePoint & jQuery
SharePoint Saturday St. Louis - SharePoint & jQuerySharePoint Saturday St. Louis - SharePoint & jQuery
SharePoint Saturday St. Louis - SharePoint & jQueryMark Rackley
 
Mobile Developers Talks: Delve Mobile
Mobile Developers Talks: Delve MobileMobile Developers Talks: Delve Mobile
Mobile Developers Talks: Delve MobileKonstantin Loginov
 
JavaScript 2.0 in Dreamweaver CS4
JavaScript 2.0 in Dreamweaver CS4JavaScript 2.0 in Dreamweaver CS4
JavaScript 2.0 in Dreamweaver CS4alexsaves
 
Dojo: Getting Started Today
Dojo: Getting Started TodayDojo: Getting Started Today
Dojo: Getting Started TodayGabriel Hamilton
 

Similaire à Demystifying The Solid Works Api (20)

Automating Analysis with the API
Automating Analysis with the APIAutomating Analysis with the API
Automating Analysis with the API
 
Robotlegs on Top of Gaia
Robotlegs on Top of GaiaRobotlegs on Top of Gaia
Robotlegs on Top of Gaia
 
JavaOne TS-5098 Groovy SwingBuilder
JavaOne TS-5098 Groovy SwingBuilderJavaOne TS-5098 Groovy SwingBuilder
JavaOne TS-5098 Groovy SwingBuilder
 
IOC + Javascript
IOC + JavascriptIOC + Javascript
IOC + Javascript
 
From Legacy to Hexagonal (An Unexpected Android Journey)
From Legacy to Hexagonal (An Unexpected Android Journey)From Legacy to Hexagonal (An Unexpected Android Journey)
From Legacy to Hexagonal (An Unexpected Android Journey)
 
Javascript unit testing, yes we can e big
Javascript unit testing, yes we can   e bigJavascript unit testing, yes we can   e big
Javascript unit testing, yes we can e big
 
닷넷 개발자를 위한 패턴이야기
닷넷 개발자를 위한 패턴이야기닷넷 개발자를 위한 패턴이야기
닷넷 개발자를 위한 패턴이야기
 
#SPSEMEA SharePoint & jQuery - What I wish I would have known a year ago..
#SPSEMEA SharePoint & jQuery - What I wish I would have known a year ago..#SPSEMEA SharePoint & jQuery - What I wish I would have known a year ago..
#SPSEMEA SharePoint & jQuery - What I wish I would have known a year ago..
 
CodeMash - Building Rich Apps with Groovy SwingBuilder
CodeMash - Building Rich Apps with Groovy SwingBuilderCodeMash - Building Rich Apps with Groovy SwingBuilder
CodeMash - Building Rich Apps with Groovy SwingBuilder
 
HTML5 for the Silverlight Guy
HTML5 for the Silverlight GuyHTML5 for the Silverlight Guy
HTML5 for the Silverlight Guy
 
Javascript Design Patterns
Javascript Design PatternsJavascript Design Patterns
Javascript Design Patterns
 
SharePoint Cincy 2012 - jQuery essentials
SharePoint Cincy 2012 - jQuery essentialsSharePoint Cincy 2012 - jQuery essentials
SharePoint Cincy 2012 - jQuery essentials
 
Smoothing Your Java with DSLs
Smoothing Your Java with DSLsSmoothing Your Java with DSLs
Smoothing Your Java with DSLs
 
MobiConf 2018 | Room: an SQLite object mapping library
MobiConf 2018 | Room: an SQLite object mapping library MobiConf 2018 | Room: an SQLite object mapping library
MobiConf 2018 | Room: an SQLite object mapping library
 
Advisor Jumpstart: JavaScript
Advisor Jumpstart: JavaScriptAdvisor Jumpstart: JavaScript
Advisor Jumpstart: JavaScript
 
Spsemea j query
Spsemea   j querySpsemea   j query
Spsemea j query
 
SharePoint Saturday St. Louis - SharePoint & jQuery
SharePoint Saturday St. Louis - SharePoint & jQuerySharePoint Saturday St. Louis - SharePoint & jQuery
SharePoint Saturday St. Louis - SharePoint & jQuery
 
Mobile Developers Talks: Delve Mobile
Mobile Developers Talks: Delve MobileMobile Developers Talks: Delve Mobile
Mobile Developers Talks: Delve Mobile
 
JavaScript 2.0 in Dreamweaver CS4
JavaScript 2.0 in Dreamweaver CS4JavaScript 2.0 in Dreamweaver CS4
JavaScript 2.0 in Dreamweaver CS4
 
Dojo: Getting Started Today
Dojo: Getting Started TodayDojo: Getting Started Today
Dojo: Getting Started Today
 

Plus de Razorleaf Corporation

COE 2017: Your first 3DEXPERIENCE customization
COE 2017: Your first 3DEXPERIENCE customizationCOE 2017: Your first 3DEXPERIENCE customization
COE 2017: Your first 3DEXPERIENCE customizationRazorleaf Corporation
 
Three Approaches to Integration that Deliver Greater PLM Value
Three Approaches to Integration that Deliver Greater PLM ValueThree Approaches to Integration that Deliver Greater PLM Value
Three Approaches to Integration that Deliver Greater PLM ValueRazorleaf Corporation
 
Discovering New Product Introduction (NPI) using Autodesk Fusion Lifecycle
Discovering New Product Introduction (NPI) using Autodesk Fusion LifecycleDiscovering New Product Introduction (NPI) using Autodesk Fusion Lifecycle
Discovering New Product Introduction (NPI) using Autodesk Fusion LifecycleRazorleaf Corporation
 
COE 2016 Live demo How to get to full Digitalization
COE 2016 Live demo How to get to full DigitalizationCOE 2016 Live demo How to get to full Digitalization
COE 2016 Live demo How to get to full DigitalizationRazorleaf Corporation
 
COE 2016: Technical Data Migration Made Simple
COE 2016: Technical Data Migration Made SimpleCOE 2016: Technical Data Migration Made Simple
COE 2016: Technical Data Migration Made SimpleRazorleaf Corporation
 
Autdoesk PLM 360 to PDM Integration with Jitterbit
Autdoesk PLM 360 to PDM Integration with JitterbitAutdoesk PLM 360 to PDM Integration with Jitterbit
Autdoesk PLM 360 to PDM Integration with JitterbitRazorleaf Corporation
 
DriveWorks World 2016 - 13 lessons in 12 years
DriveWorks World 2016  - 13 lessons in 12 yearsDriveWorks World 2016  - 13 lessons in 12 years
DriveWorks World 2016 - 13 lessons in 12 yearsRazorleaf Corporation
 
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (Tech Paper)
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (Tech Paper)AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (Tech Paper)
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (Tech Paper)Razorleaf Corporation
 
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (PPT)
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (PPT)AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (PPT)
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (PPT)Razorleaf Corporation
 
AU 2014: Autodesk PLM 360 Success Story with Inphi (PPT)
AU 2014: Autodesk PLM 360 Success Story with Inphi (PPT)AU 2014: Autodesk PLM 360 Success Story with Inphi (PPT)
AU 2014: Autodesk PLM 360 Success Story with Inphi (PPT)Razorleaf Corporation
 
AU 2014: Autodesk PLM 360 Success Story with Inphi (TECH PAPER)
AU 2014: Autodesk PLM 360 Success Story with Inphi (TECH PAPER)AU 2014: Autodesk PLM 360 Success Story with Inphi (TECH PAPER)
AU 2014: Autodesk PLM 360 Success Story with Inphi (TECH PAPER)Razorleaf Corporation
 
Deploying DriveWorks Throughout the Organization
Deploying DriveWorks Throughout the OrganizationDeploying DriveWorks Throughout the Organization
Deploying DriveWorks Throughout the OrganizationRazorleaf Corporation
 
3DVIA Composer for Assembly Instruction Storyboards
3DVIA Composer for Assembly Instruction Storyboards3DVIA Composer for Assembly Instruction Storyboards
3DVIA Composer for Assembly Instruction StoryboardsRazorleaf Corporation
 
SolidWorks Modeling for Design Automation
SolidWorks Modeling for Design AutomationSolidWorks Modeling for Design Automation
SolidWorks Modeling for Design AutomationRazorleaf Corporation
 
Connecting SolidWorks EPDM and ENOVIA V6
Connecting SolidWorks EPDM and ENOVIA V6Connecting SolidWorks EPDM and ENOVIA V6
Connecting SolidWorks EPDM and ENOVIA V6Razorleaf Corporation
 
Solving Iterative Design Problems with TactonWorks
Solving Iterative Design Problems with TactonWorksSolving Iterative Design Problems with TactonWorks
Solving Iterative Design Problems with TactonWorksRazorleaf Corporation
 

Plus de Razorleaf Corporation (20)

COE 2017: Your first 3DEXPERIENCE customization
COE 2017: Your first 3DEXPERIENCE customizationCOE 2017: Your first 3DEXPERIENCE customization
COE 2017: Your first 3DEXPERIENCE customization
 
COE 2017: Atomic Content
COE 2017: Atomic ContentCOE 2017: Atomic Content
COE 2017: Atomic Content
 
Three Approaches to Integration that Deliver Greater PLM Value
Three Approaches to Integration that Deliver Greater PLM ValueThree Approaches to Integration that Deliver Greater PLM Value
Three Approaches to Integration that Deliver Greater PLM Value
 
Discovering New Product Introduction (NPI) using Autodesk Fusion Lifecycle
Discovering New Product Introduction (NPI) using Autodesk Fusion LifecycleDiscovering New Product Introduction (NPI) using Autodesk Fusion Lifecycle
Discovering New Product Introduction (NPI) using Autodesk Fusion Lifecycle
 
COE 2016 Live demo How to get to full Digitalization
COE 2016 Live demo How to get to full DigitalizationCOE 2016 Live demo How to get to full Digitalization
COE 2016 Live demo How to get to full Digitalization
 
COE 2016: Technical Data Migration Made Simple
COE 2016: Technical Data Migration Made SimpleCOE 2016: Technical Data Migration Made Simple
COE 2016: Technical Data Migration Made Simple
 
COE 2016: 10 Cool Tools for 2016
COE 2016: 10 Cool Tools for 2016COE 2016: 10 Cool Tools for 2016
COE 2016: 10 Cool Tools for 2016
 
ENOVIA v6 R2013x Tips and Tricks
ENOVIA v6 R2013x Tips and TricksENOVIA v6 R2013x Tips and Tricks
ENOVIA v6 R2013x Tips and Tricks
 
Autdoesk PLM 360 to PDM Integration with Jitterbit
Autdoesk PLM 360 to PDM Integration with JitterbitAutdoesk PLM 360 to PDM Integration with Jitterbit
Autdoesk PLM 360 to PDM Integration with Jitterbit
 
DriveWorks World 2016 - 13 lessons in 12 years
DriveWorks World 2016  - 13 lessons in 12 yearsDriveWorks World 2016  - 13 lessons in 12 years
DriveWorks World 2016 - 13 lessons in 12 years
 
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (Tech Paper)
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (Tech Paper)AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (Tech Paper)
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (Tech Paper)
 
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (PPT)
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (PPT)AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (PPT)
AU 2015: Enterprise, Beam Me Up: Inphi's Enterprise PLM Solution (PPT)
 
AU 2014: Autodesk PLM 360 Success Story with Inphi (PPT)
AU 2014: Autodesk PLM 360 Success Story with Inphi (PPT)AU 2014: Autodesk PLM 360 Success Story with Inphi (PPT)
AU 2014: Autodesk PLM 360 Success Story with Inphi (PPT)
 
AU 2014: Autodesk PLM 360 Success Story with Inphi (TECH PAPER)
AU 2014: Autodesk PLM 360 Success Story with Inphi (TECH PAPER)AU 2014: Autodesk PLM 360 Success Story with Inphi (TECH PAPER)
AU 2014: Autodesk PLM 360 Success Story with Inphi (TECH PAPER)
 
Deploying DriveWorks Throughout the Organization
Deploying DriveWorks Throughout the OrganizationDeploying DriveWorks Throughout the Organization
Deploying DriveWorks Throughout the Organization
 
3DVIA Composer for Assembly Instruction Storyboards
3DVIA Composer for Assembly Instruction Storyboards3DVIA Composer for Assembly Instruction Storyboards
3DVIA Composer for Assembly Instruction Storyboards
 
SolidWorks Modeling for Design Automation
SolidWorks Modeling for Design AutomationSolidWorks Modeling for Design Automation
SolidWorks Modeling for Design Automation
 
Connecting SolidWorks EPDM and ENOVIA V6
Connecting SolidWorks EPDM and ENOVIA V6Connecting SolidWorks EPDM and ENOVIA V6
Connecting SolidWorks EPDM and ENOVIA V6
 
Automating SolidWorks with Excel
Automating SolidWorks with ExcelAutomating SolidWorks with Excel
Automating SolidWorks with Excel
 
Solving Iterative Design Problems with TactonWorks
Solving Iterative Design Problems with TactonWorksSolving Iterative Design Problems with TactonWorks
Solving Iterative Design Problems with TactonWorks
 

Dernier

Cloud Revolution: Exploring the New Wave of Serverless Spatial Data
Cloud Revolution: Exploring the New Wave of Serverless Spatial DataCloud Revolution: Exploring the New Wave of Serverless Spatial Data
Cloud Revolution: Exploring the New Wave of Serverless Spatial DataSafe Software
 
AI Fame Rush Review – Virtual Influencer Creation In Just Minutes
AI Fame Rush Review – Virtual Influencer Creation In Just MinutesAI Fame Rush Review – Virtual Influencer Creation In Just Minutes
AI Fame Rush Review – Virtual Influencer Creation In Just MinutesMd Hossain Ali
 
COMPUTER 10 Lesson 8 - Building a Website
COMPUTER 10 Lesson 8 - Building a WebsiteCOMPUTER 10 Lesson 8 - Building a Website
COMPUTER 10 Lesson 8 - Building a Websitedgelyza
 
Crea il tuo assistente AI con lo Stregatto (open source python framework)
Crea il tuo assistente AI con lo Stregatto (open source python framework)Crea il tuo assistente AI con lo Stregatto (open source python framework)
Crea il tuo assistente AI con lo Stregatto (open source python framework)Commit University
 
UiPath Community: AI for UiPath Automation Developers
UiPath Community: AI for UiPath Automation DevelopersUiPath Community: AI for UiPath Automation Developers
UiPath Community: AI for UiPath Automation DevelopersUiPathCommunity
 
RAG Patterns and Vector Search in Generative AI
RAG Patterns and Vector Search in Generative AIRAG Patterns and Vector Search in Generative AI
RAG Patterns and Vector Search in Generative AIUdaiappa Ramachandran
 
Empowering Africa's Next Generation: The AI Leadership Blueprint
Empowering Africa's Next Generation: The AI Leadership BlueprintEmpowering Africa's Next Generation: The AI Leadership Blueprint
Empowering Africa's Next Generation: The AI Leadership BlueprintMahmoud Rabie
 
Linked Data in Production: Moving Beyond Ontologies
Linked Data in Production: Moving Beyond OntologiesLinked Data in Production: Moving Beyond Ontologies
Linked Data in Production: Moving Beyond OntologiesDavid Newbury
 
Videogame localization & technology_ how to enhance the power of translation.pdf
Videogame localization & technology_ how to enhance the power of translation.pdfVideogame localization & technology_ how to enhance the power of translation.pdf
Videogame localization & technology_ how to enhance the power of translation.pdfinfogdgmi
 
Secure your environment with UiPath and CyberArk technologies - Session 1
Secure your environment with UiPath and CyberArk technologies - Session 1Secure your environment with UiPath and CyberArk technologies - Session 1
Secure your environment with UiPath and CyberArk technologies - Session 1DianaGray10
 
KubeConEU24-Monitoring Kubernetes and Cloud Spend with OpenCost
KubeConEU24-Monitoring Kubernetes and Cloud Spend with OpenCostKubeConEU24-Monitoring Kubernetes and Cloud Spend with OpenCost
KubeConEU24-Monitoring Kubernetes and Cloud Spend with OpenCostMatt Ray
 
Basic Building Blocks of Internet of Things.
Basic Building Blocks of Internet of Things.Basic Building Blocks of Internet of Things.
Basic Building Blocks of Internet of Things.YounusS2
 
UiPath Studio Web workshop series - Day 6
UiPath Studio Web workshop series - Day 6UiPath Studio Web workshop series - Day 6
UiPath Studio Web workshop series - Day 6DianaGray10
 
Anypoint Code Builder , Google Pub sub connector and MuleSoft RPA
Anypoint Code Builder , Google Pub sub connector and MuleSoft RPAAnypoint Code Builder , Google Pub sub connector and MuleSoft RPA
Anypoint Code Builder , Google Pub sub connector and MuleSoft RPAshyamraj55
 
Using IESVE for Loads, Sizing and Heat Pump Modeling to Achieve Decarbonization
Using IESVE for Loads, Sizing and Heat Pump Modeling to Achieve DecarbonizationUsing IESVE for Loads, Sizing and Heat Pump Modeling to Achieve Decarbonization
Using IESVE for Loads, Sizing and Heat Pump Modeling to Achieve DecarbonizationIES VE
 
Computer 10: Lesson 10 - Online Crimes and Hazards
Computer 10: Lesson 10 - Online Crimes and HazardsComputer 10: Lesson 10 - Online Crimes and Hazards
Computer 10: Lesson 10 - Online Crimes and HazardsSeth Reyes
 
Salesforce Miami User Group Event - 1st Quarter 2024
Salesforce Miami User Group Event - 1st Quarter 2024Salesforce Miami User Group Event - 1st Quarter 2024
Salesforce Miami User Group Event - 1st Quarter 2024SkyPlanner
 
Connector Corner: Extending LLM automation use cases with UiPath GenAI connec...
Connector Corner: Extending LLM automation use cases with UiPath GenAI connec...Connector Corner: Extending LLM automation use cases with UiPath GenAI connec...
Connector Corner: Extending LLM automation use cases with UiPath GenAI connec...DianaGray10
 
Designing A Time bound resource download URL
Designing A Time bound resource download URLDesigning A Time bound resource download URL
Designing A Time bound resource download URLRuncy Oommen
 
GenAI and AI GCC State of AI_Object Automation Inc
GenAI and AI GCC State of AI_Object Automation IncGenAI and AI GCC State of AI_Object Automation Inc
GenAI and AI GCC State of AI_Object Automation IncObject Automation
 

Dernier (20)

Cloud Revolution: Exploring the New Wave of Serverless Spatial Data
Cloud Revolution: Exploring the New Wave of Serverless Spatial DataCloud Revolution: Exploring the New Wave of Serverless Spatial Data
Cloud Revolution: Exploring the New Wave of Serverless Spatial Data
 
AI Fame Rush Review – Virtual Influencer Creation In Just Minutes
AI Fame Rush Review – Virtual Influencer Creation In Just MinutesAI Fame Rush Review – Virtual Influencer Creation In Just Minutes
AI Fame Rush Review – Virtual Influencer Creation In Just Minutes
 
COMPUTER 10 Lesson 8 - Building a Website
COMPUTER 10 Lesson 8 - Building a WebsiteCOMPUTER 10 Lesson 8 - Building a Website
COMPUTER 10 Lesson 8 - Building a Website
 
Crea il tuo assistente AI con lo Stregatto (open source python framework)
Crea il tuo assistente AI con lo Stregatto (open source python framework)Crea il tuo assistente AI con lo Stregatto (open source python framework)
Crea il tuo assistente AI con lo Stregatto (open source python framework)
 
UiPath Community: AI for UiPath Automation Developers
UiPath Community: AI for UiPath Automation DevelopersUiPath Community: AI for UiPath Automation Developers
UiPath Community: AI for UiPath Automation Developers
 
RAG Patterns and Vector Search in Generative AI
RAG Patterns and Vector Search in Generative AIRAG Patterns and Vector Search in Generative AI
RAG Patterns and Vector Search in Generative AI
 
Empowering Africa's Next Generation: The AI Leadership Blueprint
Empowering Africa's Next Generation: The AI Leadership BlueprintEmpowering Africa's Next Generation: The AI Leadership Blueprint
Empowering Africa's Next Generation: The AI Leadership Blueprint
 
Linked Data in Production: Moving Beyond Ontologies
Linked Data in Production: Moving Beyond OntologiesLinked Data in Production: Moving Beyond Ontologies
Linked Data in Production: Moving Beyond Ontologies
 
Videogame localization & technology_ how to enhance the power of translation.pdf
Videogame localization & technology_ how to enhance the power of translation.pdfVideogame localization & technology_ how to enhance the power of translation.pdf
Videogame localization & technology_ how to enhance the power of translation.pdf
 
Secure your environment with UiPath and CyberArk technologies - Session 1
Secure your environment with UiPath and CyberArk technologies - Session 1Secure your environment with UiPath and CyberArk technologies - Session 1
Secure your environment with UiPath and CyberArk technologies - Session 1
 
KubeConEU24-Monitoring Kubernetes and Cloud Spend with OpenCost
KubeConEU24-Monitoring Kubernetes and Cloud Spend with OpenCostKubeConEU24-Monitoring Kubernetes and Cloud Spend with OpenCost
KubeConEU24-Monitoring Kubernetes and Cloud Spend with OpenCost
 
Basic Building Blocks of Internet of Things.
Basic Building Blocks of Internet of Things.Basic Building Blocks of Internet of Things.
Basic Building Blocks of Internet of Things.
 
UiPath Studio Web workshop series - Day 6
UiPath Studio Web workshop series - Day 6UiPath Studio Web workshop series - Day 6
UiPath Studio Web workshop series - Day 6
 
Anypoint Code Builder , Google Pub sub connector and MuleSoft RPA
Anypoint Code Builder , Google Pub sub connector and MuleSoft RPAAnypoint Code Builder , Google Pub sub connector and MuleSoft RPA
Anypoint Code Builder , Google Pub sub connector and MuleSoft RPA
 
Using IESVE for Loads, Sizing and Heat Pump Modeling to Achieve Decarbonization
Using IESVE for Loads, Sizing and Heat Pump Modeling to Achieve DecarbonizationUsing IESVE for Loads, Sizing and Heat Pump Modeling to Achieve Decarbonization
Using IESVE for Loads, Sizing and Heat Pump Modeling to Achieve Decarbonization
 
Computer 10: Lesson 10 - Online Crimes and Hazards
Computer 10: Lesson 10 - Online Crimes and HazardsComputer 10: Lesson 10 - Online Crimes and Hazards
Computer 10: Lesson 10 - Online Crimes and Hazards
 
Salesforce Miami User Group Event - 1st Quarter 2024
Salesforce Miami User Group Event - 1st Quarter 2024Salesforce Miami User Group Event - 1st Quarter 2024
Salesforce Miami User Group Event - 1st Quarter 2024
 
Connector Corner: Extending LLM automation use cases with UiPath GenAI connec...
Connector Corner: Extending LLM automation use cases with UiPath GenAI connec...Connector Corner: Extending LLM automation use cases with UiPath GenAI connec...
Connector Corner: Extending LLM automation use cases with UiPath GenAI connec...
 
Designing A Time bound resource download URL
Designing A Time bound resource download URLDesigning A Time bound resource download URL
Designing A Time bound resource download URL
 
GenAI and AI GCC State of AI_Object Automation Inc
GenAI and AI GCC State of AI_Object Automation IncGenAI and AI GCC State of AI_Object Automation Inc
GenAI and AI GCC State of AI_Object Automation Inc
 

Demystifying The Solid Works Api

Notes de l'éditeur

  1. The program lists this as a beginners session, and that is the truth in that we’re targeting this session towards folks that have not yet done much in the way of SolidWorks programming. This is an intro to the SolidWorks API. We’ll look at the basics, certainly. Examples? You betcha. Details into what parameters each method and property require and return? Nope. That’s all documented for you. Well, mostly. I’ll show you how to find it on your own, but we’re not getting into that level of detail. This also is NOT a programming class. I’m not going to teach you how to write code or teach you how to use the development environments that SolidWorks provides. You folks are obviously smart, or you’d be at the SolidEdge conference. So I’m confident you can figure that stuff out on your own or find some books or info online about that.
  2. What I want to do today is to inspire you. That’s right, I perspire to inspire. I want you to walk out of here saying, wow, all I need to do is get a copy of that presentation, tape it to my wall, and I can really do this! I want you to walk out of here and be so distracted thinking of what macros and programs you’re going to write that you miss all of the other sessions. Except for my other sessions, 1:30 both tomorrow and Wednesday.
  3. Here’s the mandatory and cliché review of me and my company. Razorleaf is a services-only company providing implementation and customization, training and support for PDM including EPDM, SmarTeam, Aras, and Matrix, as well as Design Automation (that’s my specialty) including DriveWorks, Tacton, and custom solutions. As I said, services-only, so I won’t be trying to sell you anything, don’t worry.I am Paul Gimbel, known in the SolidWorks community as simply “The Sherpa.” I’ve been to every SolidWorks World, presented at quite a few of them. A trainer and demojock since the original, SolidWorks 95. So yes, I’m old, and yes, I’m starting to look it.
  4. There are a bunch of ways that you can get code into SolidWorks. The first, and easiest, is with macros. These are little scripts, little nuggets of code that you can run from inside of SolidWorks. You can use TOOLS, MACROS, RUN to execute the macro, or you can use the CUSTOMIZE SolidWorks to add your macro to a menu or as an icon. Macro features are macros that get stuck into the Feature Manager that get executed every time SolidWorks rebuilds that part of the tree. We’ll talk more about them later.Add-ins are programs that are embedded right into the SolidWorks user interface. You may have dialogs, but more likely, you will add ribbons to the SolidWorks menus, you will add a Property Manager window, and possibly something in the Task Pane on the right side of the screen.You can use code in other programs, like in an Excel or Microsoft Access macro, to launch and do things in SolidWorks.And you can also write your own programs that run all by themselves from the Windows Start menu that call SolidWorks.As you can imagine, as you go down this list, the difficulty and skill required increases.Here’s a nice handy chart to see what you can use. You’ll see that .NET is supported across the board, as is VB6. This simply means that these are languages that can be compiled and stored as separate files. You will need something like Visual Studio for these, but you can get an express version for free from Microsoft. Imagine that, getting something free from Microsoft.
  5. This presentation uses VB.NET. Why? Because it’s my presentation. Want C#? Get your own show. SolidWorks 2009 introduced the ability to macro record straight into VB.NET and C#.NET. The VB.NET can be edited with the free, included VSTA (Visual Studio Tools for Applications) environment. VB is a lot easier for beginners to understand. And VBA is dead. The only ones left using it are Microsoft Office and a few other products based on using Office. Most of the examples that you will find, in the API help and online, are in VB or VBA. Taking VBA and making it .NET is pretty easy. Making it C#, not so much. If you are only going to learn one language, make it a .NET language.
  6. Some quick myths about macros. Despite what you’ve heard, you can create forms and dialogs to interact with your users. You can automate macros quite easily. And macros do not require you to have objects preselected. Most samples have you preselect, because fetching the right feature is a pain in the assssss…embly. And you most certainly can create classes and other fun stuff in macros enabling you to automatically react when SolidWorks notifies you someone is trying to save a file, for example.
  7. Here’s the first piece of good news for those of you that question whether you can be a programmer. I was shocked to find out that even the most hardcore code junkie doesn’t write code! Everyone uses Google to find code that is close to what they want. They copy it, paste it, tweak it and test it. One of my engineering professors told me, “A good engineer knows nothing, but knows where to find everything.” At which point I asked him why his exams were not open book. But that’s right folks, life is an open book exam! So cheat as much as you can. Or as they say in codie circles, “repurpose code.”
  8. So the big deal is how to figure out what properties or methods you need and what objects those belong to. One great method, as mentioned earlier, is to use Google. Look around this convention center. There are LOTS of people here that are writing code. There are even more that didn’t make it here that are writing code. Most of them post it somewhere for free consumption. Heaven knows I do. But there actually is a lot of information in the API Help. This is a sample of an Interface or class member page. This shows all of the properties and methods for the Idimension interface, or the Dimension class.
  9. You want to look for these pages that list the MEMBERS. Remember, that’s all of your properties and methods.
  10. The properties section lists all of the properties, click on them for more info. Pay attention to whether they are read only, or if they can get AND set a value. Also pay attention to what they get. Methods are actions performed by or on the object. Follow the links to see what inputs and outputs are involved in these as well.
  11. The links give you more details, but notice that some give you back objects. Those are the accessors to other classes.
  12. Also notice that SolidWorks likes to obsolete a lot of properties and methods. Here, they took a property away and put in two methods to get and set the value.
  13. In other cases, SolidWorks will modify the property or method. In these cases, they will never remove the old member, because that would render your old code obsolete. They simply create a new function with an incremented number after it.
  14. So here it is. The ultimate process for developing a SolidWorks API program. Let’s run through it and see it in action.
  15. This macro takes a currently open part and gets a list of all of the configurations in it. It goes through them one at a time, activating the configuration, changing its material, rebuilding it, saving it as a PDF, and adding a configuration-specific property to it.
  16. These are some of the fun things that I hope you will take out of this example. Most important is the flow for how you obtain objects and use them. These are also very common actions for API macros, so you will be able to “repurpose” my code to your heart’s delight.
  17. OK, here’s the process. Step 1, use Macro Recorder to perform one or more steps of what you’re trying to do. Then check out what SolidWorks came up with to see if it’s useful or at least provides any useful clues.
  18. This is what the macro recorder recorded when I changed the material for a few configs. The code is split onto this slide and the next. The most important things to note about the macro recorder are that it will record a lot of things that you do not care about and it may not record everything that you are after. So why record at all? Well, it’s quick, doesn’t cost much, and you may find clues to the members and objects and maybe even some some snippets that you can use. So let’s take a look at the basic format of the macro and at what SolidWorks is putting in here. First is the stuff in blue. It’s the header. It’s always going to be there. Let’s look at the declarations on slide 1. We’ve got a ModelDoc2. You’ll learn soon that you pretty much ALWAYS have a ModelDoc2. A PartDoc, ok, sounds reasonable since we’re working with a part. But look at these variables. A DrawingDoc object? Don’t need it. AssemblyDoc? Nope. In fact, over half of these are extraneous, unnecessary variables that are declared and never used. Minus 15 style points. But there, at the bottom, there it is. SetMaterialPropertyName2. That’s it. Jot it down, copy it to your clipboard, whatever you want to do. THAT is what we’re after.
  19. The second half isn’t all that much help. The other thing that you’ll see a lot in the macro recorder are selections, clears, view changes and a bunch of other clicks that we will never replicate in a macro. We do see, however, a nice little ShowConfiguration2. That one sounds useful, we’ll tuck that away as well. Some other thins to notice in the format, we have a summary here, at the end, where nobody will see it. And we have the swApp. The most important variable in the whole class. So important that it’s hidden away.
  20. Barebones, this is what you should have. It starts with these IMPORTS statements that tell VB what libraries classes you’re going to be pulling from. This is what allows us to say DIM swDoc As ModelDoc2, and VB knows what a ModelDoc2 is. You will notice that these are conspicuously missing from my final code. The objects instead have their full names. I prefer to do it that way. It is longer, but actually not that much more typing and it makes it a lot easier to read and follow later on. You should ALWAYS use Tools, Macro, New or Tools, Macro, Record, or if you have a template that you already built from one of those two sources, that’s fine. Make sure that you let SolidWorks built your framework, though.
  21. Your class definition header is next, telling everyone what your class is going to be called. Leave the PARTIAL in there. It shows that there is a lot more going on behind the scenes than you know. If you want to change the name of your class, for goodness, sake, don’t just type over it here.
  22. If you MUST rename it, do it in the Project Explorer on the right side. A quick peek at the SHOW ALL button reveals that there is a WHOLE LOT of stuff that you don’t normally see. Just typing over that name will cause untold levels of problems.
  23. Comments are critical and they belong right here up front. Anything after an apostrophe is treated as a comment and ignored. Use them A LOT! This swApp is also really important, so it deserves to be up front. It doesn’t make it run any differently, it just adds visibility to the most important object you have.
  24. OK, so we did our macro recorder, we actually got what we think are two of the methods that we need. Let’s do some research.
  25. We’ll stick with the SolidWorks API Help, because you really need to see how to use it. It’s takes some finesse. We know we need to deal with configurations. We want a list of the config names. So let’s just search on CONFIGURATION. Here’s what we find. The first entry (of 500) looks somewhat relevant, so let’s follow the link. That shows us that there’s a ConfigurationManager object. OK, I’ll bite. Let’s see if we need that.
  26. So here, I didn’t see anything that really meant anything to me, but I did notice that there were a lot of examples. This one especially caught my eye, because it talks about doing something with ALL CONFIGURATIONS. Now it’s VBA, not VB.NET, but what I’m really looking for at this point is what objects and what methods do I need. That’s going to be universal. And VBA and VB.NET aren’t THAT much different in terms of readability. I would stay away from the C# examples if vous no parlez C++.
  27. So I scanned through that code and it was pretty simple at the top. A bunch of DIM statements. I know what those are. But down here, we see swModel.GetConfigurationNames. That sounds REALLY good. What doesn’t look so good is that they’re using VARIANTS. That means we need to do more research to figure out how to use this method.
  28. OK, so we found the method that we need. We’ll search on that and the search comes up with GetConfigurationNames. Great, let’s follow it. OK, that’s obsolete. Quite often, you will get the obsolete one first. Don’t worry, just keep going.
  29. The obsolete one led us to the current one. So from this screen, we get a few pieces of information, very few. One, we see what object we need to have to take this action, the ModelDoc2 object. Second, we find out what SolidWorks returns to us, sort of. It gives us back an object. Um, that could pretty much be anything. It’s a bit of a cop-out if you ask me. Down here, they give you a little more info, letting you know that it is an array. VBA was very sloppy and let you get away with a lot, but in .NET, we need to know for sure. It turns out to be an array of strings. How do I know? I guessed and tried it.
  30. OK, so we did our research. Onto the next step.
  31. In VB, we need to declare, or tell VB what our variables are going to be before we use them. We do this with a PUBLIC or DIM statement. We tell it the variable name that we’re going to use and we tell it the class of the object. Once VB knows what it’s going to be, we can then put a value or assign an object to it. Remember that Accessors are the methods that are used to obtain objects. You need an object to get an object. Sometimes, though, we’re not 100% sure what we’re getting back from our accessor, so we use an insurance function, called Ctype, that converts the output from the accessor into the specific type that we want. DirectCast is also sometimes used for pretty much the same reason. So don’t be shocked if you see these.
  32. At the top, we can put variables that we know we’re going to use. Notice that we can declare and define in a single line.We can also define them as we go, so don’t worry if you don’t know them all. You can put them up here later, or just declare them down in the code.
  33. The first thing that we need to do is to latch onto the open session of SolidWorks. There are three common ways to do this. You can just set it to Application.Sldworks. This requires that SolidWorks be open and running. If you’re running a macro, then it’s a pretty good bet that SolidWorks is running. You can do a GetObject which is a bit more robust, and what’s cool about this one is that you can put a parameter in here telling SolidWorks which window to open. This is not a FILE, OPEN, this gets you latched onto the SolidWorks Application with a certain document window open. If the document and SolidWorks are not open, Error City, USA. CreateObject is a bit more robust in that it will open SolidWorks if it’s not already open. Great for standalone apps or calling SolidWorks from another program.
  34. So we need to grab the ModelDoc2 object. Why? Because the process says that we always need to. Remember that accessors are methods, so we need an object to access other objects. What object is that? Typically, it’s the ModelDoc2. So we’re going to use the swApp object with its accessor .ActiveDoc to get the ModelDoc2 object. Where do we define the swApp object? Well, that’s done by SolidWorks in that big jumble of stuff that’s hidden from you. It is ALWAYS important that whenever you define or instantiate an object, that you check to make sure that you have it. If you assume that you have it and go on, SolidWorks will barf at you and your users will laugh at you.
  35. It is very important to know where the method or property that you need lies. ModelDoc2 does an awful lot. So much in fact, that they had to create another object, ModelDoc2.Extension. But some other things that you would imagine would be on the ModelDoc2 are more document-type specific. So you need to get a PartDoc object or AssemblyDoc object or DrawingDoc object.
  36. So now we have the ModelDoc2, and we know that the ModelDoc2 can get us the configuration names. The first thing that we do is check to make sure that we got names. If we do, then we start looping through them. For Each…In loops are a great way to go through arrays or collections without having to care how many there are. Within the loop, we’ll switch the active config with the ShowConfiguration2 that we saw in the macro recorder, and we’ll rebuild as well. It’s interesting to note that these methods actually return a true/false value telling you if they worked or not. In practice, you will want to do an IF…THEN to make sure that they succeeded. And we will always be careful to close out our loops and our IF blocks.
  37. So we have our ModelDoc2 and we used it to get the config names. Now we need to change the material and we know that’s on the PartDoc object.
  38. Now normally we would use an accessor to get the Part object from the modeldoc2 object. But ModelDoc2 has a weird relationship with PartDoc, AssemblyDoc and DrawingDoc. They’re kind of the same. So you don’t need an accessor, you just set them equal. This is the only place you will see this, so don’t worry. This is generally the only time we’ll use DirectCast, too. So just set swPart equal to our ModelDoc2 object, swDoc, and recast it as a PartDoc object. Notice that we are outside of the loop, that is, before we start going through the configs because we don’t want to reassign this every time. But back inside the loop, we can then go ahead and set the material since we now have the right object.
  39. Saving the model as a PDF is pretty easy. All of the methods that we need to use are on the ModelDoc2 object. We’re doing a little string manipulation here. By the way, go online and check out the VB.NET string members, they are way cool. You may also see this from time to time. A space-underscore means that this was too long to fit on one line, so it bleeds over to the next. I has to be a space-underscore. Not just an underscore. Down here, you can see that we have methods that will return values listed in the parameters. In the API Help, they’re listed as BYRef. ByVal, means that you are giving an input to the method, ByRef means that you are getting an output. Since you can only have one thing on the left side of an equals, this is how they pass back more. And finally, notice that two of the parameters here, VERSION and OPTIONS are integers. We use enumerations for these.
  40. Enumerations are nothing more than aliases. Why they make them a number, I have no idea. What is the integer representing SolidWorks 2009? Who knows. So instead, we use an enumeration. The enumerations are stored in the SolidWorks.Interop.swconst (that’s out second IMPORTS that we always have at the top). The help will tell you (if you click) what enumeration to use, but if you just type SolidWorks.Interop.swconst (you’ll see that it autofills in most of it for you), then you will get a nice list to choose from. So you will not need to memorize any of these…ever.
  41. The last step that we have is to set the custom property. Here we’re using another cool VB.NET string function. And what’s most important here is that we’re closing out our loops and our IF…THEN blocks. But which is which? You could have a half-dozen END Ifs in a row. That is not uncommon. A nice little comment afterwards lets you easily keep track of which is which.
  42. And here is the complete code for the configuration example.
  43. This example was for a company that uses DriveWorks to automate the design of their parts. DriveWorks has the ability to kick off a macro upon the completion of the generation of a part, and these folks had a bit of an odd situation. For anonymity’s sake, let’s say that they make plates with holes. The plates come in different sizes with different size hole patterns. The customizability comes in because not every hole is needed every time. So we needed a way for the end user, a non-SolidWorks user, you specify which holes needed to be there, and which holes should not. In SolidWorks this is easy, you right-select the pattern, edit definition, then choose the instances to skip from the pattern. But this was automated. There’s nobody there to pick. So what we did was to have DriveWorks generate a series of Xs and Os representing the pattern. X means there’s a hole and O means there is no hole. DriveWorks passed this into the part as a custom property. Our macro would then read the custom property, scan the part for a pattern that matched, then do its magic.
  44. This one is fun because it works with features. It shows you how to loop through features, looking for patterns, and it deals with something that comes up often and is a bit weird, a FeatureData object. And now we get to read a custom property that we learned to write in the last example.
  45. So we’re going to follow the same process. Step one, macro record.
  46. So this is what we get out of the Macro Recorded this time. We see our ModelDoc2, which we know we’re going to need and…well, that’s about it. You can see the Hole Pattern being selected, but that’s about it. No help whatsoever. This happens sometimes.
  47. So we go into the research phase empty handed. No worries.
  48. We know we want to work with linear patterns. So let’s search on Linear Pattern and see what comes up. ILinearPatternFeatureData. That sounds like quite the interesting class, let’s see what it’s all about, and more importantly, what properties and methods it has. We look at the interface page and we see the link for the MEMBERS which will tell us what properties and methods this class has. We also notice the accessors area at the bottom that tells us how to obtain this object.
  49. So looking at the members for that ILinearPatternFeatureData object, we see towards the bottom, a SkippedItemArray property. This allows us to get or set the list of instances to skip. Sounds precisely like what we want.
  50. So how do we get this ILinearPatternFeatureData object, then? Well, the Accessors section says to use Feature.GetDefinition. By the way, this double colon really means nothing. When you use it, you will use it with a dot like you always do. You will use swFeature.GetDefinition. OK, so the GetDefinition Accessor is a method of the Feature class or Ifeature Interface. How do we get the Feature object? Simply click on the link for the IFeature interface and look at its page. Scroll down to the accessors are and here are the accessors. As you can see, there are more than a few ways to get a feature object.
  51. OK, so let’s look just at the ways to get from a ModelDoc2 or a PartDoc to a feature. There are a few good candidates here. We’ve got FirstFeature, which I’m guessing is descriptively named, and FeatureByName. Well we COULD force the user to provide a specific name to the Linear Pattern Feature, but that would make this code a bit too specific, not very reusable or flexible. So we’ll grab the first feature, but can we get to the next feature from there? Well let’s look at the accessors to get from one feature to another. Sure enough, there’s GetNextFeature.
  52. So here’s the flow. We get our ModelDoc, We use that to get the first feature, then we cycle through the features. If it’s a pattern, we check to see if it’s the right size. If not, we use that feature object to get the next feature.
  53. OK, we know what to do, let’s do it
  54. OK, so let’s get our ModelDoc2 object and then test it for existence, and test it to make sure that it’s a part.
  55. OK, let’s get the rest of our objects and use them!
  56. Let’s start by retrieving the list from the custom property. Again, we’ll declare and define in the same line. Custom properties are retrieved with methods from the ModelDoc2 object. We’ll immediately test the string to make sure that it’s a good string. Once we know we have a good string, we’ll retrieve that first feature. Now note, that the first feature is WAY UP there on the tree. You will get a lot of features that you didn’t even know were features.
  57. Now that we have our first feature, let’s start looping. We have a few variables that we’ll need. One to tell us how many rows and one for how many columns. OurLinearPatternFeatureData object, and a string to check the type of feature that we have. How do I know I’m going to need these? Because I already wrote the code. You find them as you go along, and you add them to the list. We’ll use a DO WHILE loop, because it checks before it runs through each iteration of the loop. So we make sure that we have a feature object, and once we know that we do, then we start processing it.
  58. The first step is to get the feature type, that’s a method called GetTypeName2 on the feature. The best way to find most of these is to declare the feature object, then just type swFeature dot. As soon as you hit that dot, Microsoft will show you a list of all of the members of that class. It’s called Intellisense. Once you start calling a method, it then tells you wnaat parameters of what classes you need. You don’t need to go to the API Help all the time. So once we see that it is a linear pattern, then do the GetDefinition to get the LinearPatternFeatureData object. Once we have that object, we can pull the direction1 and direction2 quantities off of it to find the size of the matrix. Check that against the length of the string. If it’s a match, then we can move on.
  59. Now the last piece to this puzzle is to take the string and turn it into a list, a numerical list, of instances to be skipped. SolidWorks wants an array, but we’re going to use another VB.NET tool to get there. The Collection. I’m not going to go into details about collections, again, this is not a programming class, but the difference between a collection and an array is one of flexibility. Arrays are a predefined size. If you want to change the size, you have to re-declare it. Sorting, shuffling, and other such actions are not that easy with arrays. Collections are more flexible. The drawers are a fixed size with a fixed number of slots in each drawer. With collections, you just add on another bin and another and another. VB.NET has a ton of great methods for working with collections.
  60. So how does SolidWorks number these linear pattern instances? This way. How do I know? I tried it. Sometimes, that’s what you have to do.
  61. So what we want to do is to walk through the string, counting as we go. And every time we hit an O, then we throw that number into the collection. It’s a pretty basic, but pretty cool little loop. Things to note here are that in a string, the substring starts at position 0. We’re also using the EQUALS method to compare strings instead of a regular equal sign. This allows us to use a comparison method that ignores case. Again, how do you remember the enumerations? You don’t. Intellisense gives them to you.
  62. So we built our collection with our loop, but SolidWorks wants an array. Not a problem, VB.NET collections have a method called ToArray. This is another commonoccurance within SolidWorks, especially when you’re working with features. Once you have pushed values to properties in an object. In order for those changes to be propagated to the model, you need to kick off some form of Modify or Update method. The other critical thing is that when you make any changes to the model, you will want to rebuild. The last thing that we’re showing here is how to handle the ELSE cases. What happens when the pattern is not the right size? Well when you’re testing, throwing a message box is nice. But when you’re having others use the program, they don’t like seeing errors. So what we did was to write the error out to a custom property. We built the message by piecing together some strings and properties, then passed that string to a custom property.
  63. And here’s your finished code.
  64. DOCUMENT EVERYTHING!!! I cannot stress this enough. You want to see as much, if not more green in your code than any other color. Use your comments to turn the VB, which sounds roughly like English, into complete, sensible sentences. Make sure you use it to keep track of IF blocks and loops.
  65. Here are a couple of things that I want you to always do. In VBA, make your first line, ALWAYS, OPTION EXPLICIT. What that does is that it requires you to tell VBA what your variables are before you use them. You have to declare or DIM your variables. In VB.NET, this is always a requirement. Think of it as the REQUIRE FULLY DEFINED SKETCHES of the programming world.So you have to DIM your variables. You can be vague about them and declare them of type object, or you can tell VBA exactly what kind of object it’s going to be. Being very specific like this is called early binding or fully qualifying your variables. It is a MUST. IF you do this, your code will be easier to read and when you hit a period after your object variable’s name to get to a property or method, you will get a list to choose from. Select a method and Intellisense will tell you what parameters you need to provide in what data types. All that, just for being tidy.In VB.NET, we’re used to having SolidWorks putting the IMPORTS at the top of our macro so that we can shortcut our SolidWorks class names. Yes, it’s shorter, but I recommend spelling it out. It makes it easier to follow.
  66. We check our return values to make sure that we have objects and we check to make sure that we are getting non-empty strings, and so on. But you’re still going to get errors. Look into the methods that are available to handle these errors. TRY…CATCH blocks in VB.NET are very powerful. OnErrorGoto is good both in VB.NET and VBA.
  67. This one is a bit controversial, but I like it. Hungarian notation means that you put an abbreviation at the beginning of your variable to show what kind of variable it is. I for integer, d for double, s for string, and so on. I put sw for SolidWorks objects. You can get more specific if you want. If you’re a seasoned coder and you think this is a terrible idea, then don’t use it.
  68. I’ve also included a little slide here listing some of the VB.NET functionality that you should know. Check these out and Google them to see what they are and how they work.
  69. The last thing I want you to hear and think about is what kind of things you can do with the API. This is the part of the show where you start to think of what your first project is going to be.
  70. Number one is don’t limit yourself to just what core SolidWorks can do. Most of the SolidWorks add-ins that come with Premium include APIs. Everything from SolidWorks Utilities to Simulation to PDM and Routing. It’s all in there. I’ll be doing a presentation tomorrow about Automating Design Validation with the API. You’re ready for that now. On Wednesday, I’ll be doing a session on linking Excel with SolidWorks through the API and VBA. Same can be done with MathCAD or other calculation engines. Use them to calculate and pass values to SolidWorks. Then have SolidWorks do a mass prop or a simulation run, then send values back. But the big reasons to write macros are to save time, create iterations that can be performed quickly so you can do more iterations, and finally, to allow people who are not as smart as you to use the power of SolidWorks.
  71. Finally, I said I would mention macro features. The concept here is that you embed a macro into a feature in the feature manager. When SolidWorks rebuilds, it starts at the top and works its way down. When it hits the Macro Feature, it fires the code off. This could be a validation step, it could run a mass props and update your geometry to accommodate. The sky’s the limit. There’s lots of good info out there on Macro Features as well if you’re interested. The most important thing of all is to start thinking of how you can use this, then GO TRY IT!!
  72. If you have questions, I’ll be happy to take them now or at any time during or after the conference. If you see me in the hall, feel free to grab me. Just be careful where you grab me. I’m ticklish. If I can’t talk then, we can set up a time to sit down and chat.